//      html   ,       .
//  html-      , :
// <w lex='' gr='S,f,inan=pl,acc'></w> 
//      gr    "w"        (  aot.ru):
// <ana lemma="" pos="," gram=",,,,"  stress="255"/>
//           xml,    MorphCorpusCreator.


#include "../common/util_classes.h"
#include "RusCorpHtml.h"



void PrintUsageAndExit()
{
	printf ("RusCorpusXmlConvertor \n");
	printf ("Usage: RusCorpusXmlConvertor <type> <in-file> <out-file>\n\n");
	printf ("<type>:\n");
	printf (" xml - output file in xml format\n");
	printf (" wordform  - output only word forms\n");
	printf (" text - output file in text format (one sentence per line)\n");
	printf (" html - output file in html format\n");
	exit(1);
};



int main(int argc, char* argv[])
{
	if (argc  != 4) 
	{
			PrintUsageAndExit();
		
	}
	string OutputFormat = argv[1];
	if	(		(OutputFormat != "xml")
			&&	(OutputFormat != "text")
			&&	(OutputFormat != "html")
			&&	(OutputFormat != "wordform")
		)
	{
		fprintf (stderr, "bad output format:%s\n", OutputFormat.c_str() );
		PrintUsageAndExit();

	}
	fprintf (stderr, "RusCorpusXmlConvertor, converting html to xml\n");

	string InFileName = argv[2];
	if (!FileExists(InFileName.c_str()))
	{
		fprintf (stderr, "Cannot open file  %s\n", InFileName.c_str());
		return 0;
	}
	if (FileSize(InFileName.c_str()) == 0)
	{
		fprintf (stderr, "File  %s is empty\n", InFileName.c_str());
		return 0;
	}

	
	vector<CHtmlItem> Items;
	string SourceFileContents;
	if (!GetHtmlItems(InFileName, Items, SourceFileContents))
	{
		fprintf (stderr, "cannot process  %s\n", InFileName.c_str());
		return 1;
	};

	string bibl;
	int StartItemNo = ReadHeader( Items, bibl, InFileName);
	if (StartItemNo==-1)
		return 1;


	FILE* out_fp = fopen (argv[3], "w");
	if (!out_fp) 
	{
		fprintf (stderr, "cannot write %s\n", argv[3]);
		return 1;
	};
	int SentCount;;
	if	(OutputFormat == "xml")
		SentCount = PrintXmlFile(out_fp, Items, bibl, StartItemNo);
	/* else
	if	(OutputFormat == "html")
		SentCount = PrintHtmlFile(out_fp,Items, StartItemNo, SourceFileContents); */
	else
	if	(OutputFormat == "wordform")
		SentCount = PrintWordFormFile(out_fp,Items, StartItemNo, SourceFileContents);
	/* else
		if	(OutputFormat == "text")
			SentCount = PrintTextFile(out_fp,Items, StartItemNo); */

	fclose (out_fp);

	if (SentCount == 0)
	{
		fprintf (stderr, "No sentence found in the input file\n");
		return 1;
	}
	if (SentCount == -1)
	{
		fprintf (stderr, "Cannot parse file %s\n", InFileName.c_str());
		return 1;
	}
	
	return 0;
}




